<?php 
/**
 * Model for Suppliers
 *
 * @author Mills ABeiku Godfred
 */
class Supplier
{
	
	public $conn;
	
	function __construct()
	{
		$this->conn = Database::connect();
	}

    public function update_supplier(array $key_col_vals, array $values) {
        $sql = "UPDATE supplier SET ";
        $fields = array_keys($values);
        $vals = array_values($values);
        $key_cols = array_keys($key_col_vals);
        $key_vals = array_values($key_col_vals);
        foreach ($fields as $i=>$f) {
            $fields[$i] .= " = ? ";
        }

        $sql .= implode(",", $fields);
        $sql .= " WHERE " ;
        
        foreach ($key_cols as $i=>$f) {
            $key_cols[$i] .= " = ? ";
        }
        
        $sql .= implode(" AND ", $key_cols);

        $statement = $this->conn->prepare($sql);
        foreach ($vals as $i=>$v) {
            $statement->bindValue($i+1, $v);
        }
        
        foreach ($key_vals as $i=>$v) {
           if($i==0){
               $statement->bindValue((count($fields)+$i+1), $v);
            }else{
               $statement->bindValue((count($fields)+$i), $v);
            }
        }
        
       return  $statement->execute();

	}


	public function add_supplier(array $data){
		$sql = "INSERT INTO supplier ";
		$fields = array_keys($data);
		$vals = array_values($data);

		$sql .= "(".implode(",", $fields).")";
		$arr = array();
		foreach ($fields as $f) {
			$arr[] = "?";
		}
		$sql .= " VALUES(".implode(",", $arr).")";

		$statement = $this->conn->prepare($sql);

		foreach ($vals as $i => $v) {
			$statement->bindValue($i + 1, $v);
		}

		return $statement->execute();

	}
  
	
	public function read_all_suppliers(){
		$sql = "SELECT * FROM supplier";
		$statement = $this->conn->prepare($sql);
		$statement->execute();
		if ($statement->rowCount() > 0) {
			return $statement->fetchAll(PDO::FETCH_ASSOC);
		}
		return false;
    }

	public function get_supplier_by_name($supplier_company){
		$sql = "SELECT * FROM supplier WHERE supplier_company LIKE '%".$supplier_company."%'";
		$statement = $this->conn->prepare($sql);
		$statement->execute();
		if ($statement->rowCount() > 0) {
			return $statement->fetchAll(PDO::FETCH_ASSOC);
		}
		return false;
	}

    // public function check_username($username){
	// 	$sql = "SELECT a.*,b.* FROM supplier a JOIN supplier b 
    //     ON a.phone=b.supplier_phone || a.email=b.supplier_email 
    //     JOIN role c ON b.supplier_role_id=c.role_id
    //      WHERE a.email=:username || a.phone=:username";
	// 	$statement = $this->conn->prepare($sql);
	// 	$statement->bindParam(":username",$username);
	// 	$statement->execute();
	// 	if ($statement->rowCount() > 0) {
	// 		return $statement->fetchAll(PDO::FETCH_ASSOC);
	// 	}
	// 	return false;
    // }

    public function remove_supplier($supplier_id){
		$sql = "DELETE FROM supplier WHERE supplier_id=:supplier_id";
		$statement = $this->conn->prepare($sql);
        $statement->bindParam(":supplier_id",$supplier_id);
		$statement->execute();
		if ($statement->rowCount() > 0) {
            $statement->fetchAll(PDO::FETCH_ASSOC);
		}
		return false;
    }

}